/*
 * 创客职级信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserRankController : BaseController
    {
        public UserRankController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客职级信息列表

        /// <summary>
        /// 根据条件查询创客职级信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserRank data, int? sStatMonth, int? eStatMonth, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            List<UserLevelSet> Levels = db.UserLevelSet.OrderBy(m => m.Id).ToList();
            ViewBag.Levels = Levels;
            return View();
        }

        #endregion

        #region 根据条件查询创客职级信息列表

        /// <summary>
        /// 创客职级信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserRank data, string MakerCode, string RealName, string StatMonthSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Rank", "0"); //创客等级

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //统计月份
            if (!string.IsNullOrEmpty(StatMonthSelect))
            {
                string[] datelist = StatMonthSelect.Split('-');
                condition += " and StatYear=" + datelist[0] + " and StatMonth=" + datelist[1].TrimStart('0');
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserRank", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int Rank = int.Parse(dic["Rank"].ToString());
                UserLevelSet level = db.UserLevelSet.FirstOrDefault(m => m.Id == Rank) ?? new UserLevelSet();
                dic["Rank"] = level.Name;
                int WhiteRank = int.Parse(dic["WhiteRank"].ToString());
                level = db.UserLevelSet.FirstOrDefault(m => m.Id == WhiteRank) ?? new UserLevelSet();
                dic["WhiteRank"] = level.Name;
                dic["WhiteRankMinTrade"] = level.UpLevelGrowth;
                dic["WhiteRankMaxTrade"] = level.UpLevelIntegral;
                int NextRank = int.Parse(dic["NextRank"].ToString());
                level = db.UserLevelSet.FirstOrDefault(m => m.Id == NextRank) ?? new UserLevelSet();
                dic["NextRank"] = level.Name;
                dic["NextRankMinTrade"] = level.UpLevelGrowth;
                dic["NextRankMaxTrade"] = level.UpLevelIntegral;
                string StatYear = dic["StatYear"].ToString();
                string StatMonth = dic["StatMonth"].ToString();
                if(StatMonth.Length == 1) StatMonth = "0" + StatMonth;
                dic["StatMonth"] = StatYear + StatMonth;
            }
            return Json(obj);
        }

        #endregion

        #region 增加创客职级信息

        /// <summary>
        /// 增加或修改创客职级信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客职级信息

        /// <summary>
        /// 增加或修改创客职级信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserRank data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserRank", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserRank", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客职级信息

        /// <summary>
        /// 增加或修改创客职级信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserRank editData = db.UserRank.FirstOrDefault(m => m.Id == Id) ?? new UserRank();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客职级信息

        /// <summary>
        /// 增加或修改创客职级信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserRank data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRank", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserRank", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客职级信息信息

        /// <summary>
        /// 删除创客职级信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserRank", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRank", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserRank", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRank", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserRank", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRank", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserRank", Sort, Id);

            AddSysLog(Id.ToString(), "UserRank", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserRank.Add(new UserRank()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserRank", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserRank data, string MakerCode, string RealName, string StatMonthSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Rank", "0"); //创客等级

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //统计月份
            if (!string.IsNullOrEmpty(StatMonthSelect))
            {
                string[] datelist = StatMonthSelect.Split('-');
                condition += " and StatYear=" + datelist[0] + " and StatMonth=" + datelist[1].TrimStart('0');
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserRank", Fields, "Id desc", "0", 1, 20000, condition, "UserId,StatYear,StatMonth,Rank,WhiteRank,NextRank,TradeAmt,OperateDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int Rank = int.Parse(dic["Rank"].ToString());
                UserLevelSet level = db.UserLevelSet.FirstOrDefault(m => m.Id == Rank) ?? new UserLevelSet();
                dic["Rank"] = level.Name;
                int WhiteRank = int.Parse(dic["WhiteRank"].ToString());
                level = db.UserLevelSet.FirstOrDefault(m => m.Id == WhiteRank) ?? new UserLevelSet();
                dic["WhiteRank"] = level.Name;
                dic["WhiteRankMinTrade"] = level.UpLevelGrowth;
                dic["WhiteRankMaxTrade"] = level.UpLevelIntegral;
                int NextRank = int.Parse(dic["NextRank"].ToString());
                level = db.UserLevelSet.FirstOrDefault(m => m.Id == NextRank) ?? new UserLevelSet();
                dic["NextRank"] = level.Name;
                dic["NextRankMinTrade"] = level.UpLevelGrowth;
                dic["NextRankMaxTrade"] = level.UpLevelIntegral;
                string StatYear = dic["StatYear"].ToString();
                string StatMonth = dic["StatMonth"].ToString();
                if(StatMonth.Length == 1) StatMonth = "0" + StatMonth;
                dic["StatMonth"] = StatYear + StatMonth;
                dic.Remove("UserId");
                dic.Remove("StatYear");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客名称");
            ReturnFields.Add("Rank", "当前等级名称");
            ReturnFields.Add("WhiteRank", "白名单等级名称");
            ReturnFields.Add("WhiteRankMinTrade", "对应档位最小交易量（万）");
            ReturnFields.Add("WhiteRankMaxTrade", "对应档位最大交易量（万）");
            ReturnFields.Add("NextRank", "下个等级名称");
            ReturnFields.Add("NextRankMinTrade", "下个等级对应档位最小交易量（万）");
            ReturnFields.Add("NextRankMaxTrade", "下个等级对应档位最大交易量（万）");
            ReturnFields.Add("StatMonth", "统计月份");
            ReturnFields.Add("TradeAmt", "团队交易总额（万）");
            ReturnFields.Add("OperateDate", "修改时间");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserRank", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
